<a id="mypy-boto3-route53-recovery-control-config"></a>

# mypy-boto3-route53-recovery-control-config

[![PyPI - types-aiobotocore-route53-recovery-control-config](https://img.shields.io/pypi/v/types-aiobotocore-route53-recovery-control-config.svg?color=blue)](https://pypi.org/project/types-aiobotocore-route53-recovery-control-config)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-route53-recovery-control-config.svg?color=blue)](https://pypi.org/project/types-aiobotocore-route53-recovery-control-config)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-route53-recovery-control-config?color=blue)](https://pypistats.org/packages/types-aiobotocore-route53-recovery-control-config)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.Route53RecoveryControlConfig 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/route53-recovery-control-config.html#Route53RecoveryControlConfig)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-route53-recovery-control-config docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_route53_recovery_control_config/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-route53-recovery-control-config](#mypy-boto3-route53-recovery-control-config)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Waiters annotations](#waiters-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `Route53RecoveryControlConfig`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `Route53RecoveryControlConfig` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[route53-recovery-control-config]'

# Lite version does not provide session.create_client overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[route53-recovery-control-config]'

# standalone installation
python -m pip install types-aiobotocore-route53-recovery-control-config
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[route53-recovery-control-config]` in your
  environment:
  `python -m pip install 'types-aiobotocore[route53-recovery-control-config]'`

Both type checking and auto-complete should work for
`Route53RecoveryControlConfig` service. No explicit type annotations required,
write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[route53-recovery-control-config]` in your
  environment:
  `python -m pip install 'types-aiobotocore[route53-recovery-control-config]'`

Both type checking and auto-complete should work for
`Route53RecoveryControlConfig` service. No explicit type annotations required,
write your `aiobotocore` code as usual. Auto-complete can be slow on big
projects or if you have a lot of installed `types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[route53-recovery-control-config]` in your
  environment:
  `python -m pip install 'types-aiobotocore[route53-recovery-control-config]'`
- Run `mypy` as usual

Type checking should work for `Route53RecoveryControlConfig` service. No
explicit type annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[route53-recovery-control-config]` in your
  environment:
  `python -m pip install 'types-aiobotocore[route53-recovery-control-config]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `Route53RecoveryControlConfig` service. No
explicit type annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`Route53RecoveryControlConfigClient` provides annotations for
`session.create_client("route53-recovery-control-config")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_route53_recovery_control_config import Route53RecoveryControlConfigClient

session = get_session()
async with session.create_client("route53-recovery-control-config") as client:
    client: Route53RecoveryControlConfigClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="waiters-annotations"></a>

### Waiters annotations

`types_aiobotocore_route53_recovery_control_config.waiter` module contains type
annotations for all waiters.

````python
from aiobotocore.session import get_session

from types_aiobotocore_route53_recovery_control_config.client import Route53RecoveryControlConfigClient
from types_aiobotocore_route53_recovery_control_config.waiter import (
    ClusterCreatedWaiter,
    ClusterDeletedWaiter,
    ControlPanelCreatedWaiter,
    ControlPanelDeletedWaiter,
    RoutingControlCreatedWaiter,
    RoutingControlDeletedWaiter,
)

session = get_session()
async with session.create_client("route53-recovery-control-config") as client:
    client: Route53RecoveryControlConfigClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        cluster_created_waiter: ClusterCreatedWaiter = client.get_waiter("cluster_created")
        cluster_deleted_waiter: ClusterDeletedWaiter = client.get_waiter("cluster_deleted")
        control_panel_created_waiter: ControlPanelCreatedWaiter = client.get_waiter("control_panel_created")
        control_panel_deleted_waiter: ControlPanelDeletedWaiter = client.get_waiter("control_panel_deleted")
        routing_control_created_waiter: RoutingControlCreatedWaiter = client.get_waiter("routing_control_created")
        routing_control_deleted_waiter: RoutingControlDeletedWaiter = client.get_waiter("routing_control_deleted")
    ```





### Literals

`types_aiobotocore_route53_recovery_control_config.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_route53_recovery_control_config.literals import (
    ClusterCreatedWaiterName,
    ClusterDeletedWaiterName,
    ControlPanelCreatedWaiterName,
    ControlPanelDeletedWaiterName,
    RoutingControlCreatedWaiterName,
    RoutingControlDeletedWaiterName,
    RuleTypeType,
    StatusType,
    ServiceName,
    WaiterName,
)

def check_value(value: ClusterCreatedWaiterName) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_route53_recovery_control_config.type_defs` module contains
structures and shapes assembled to typed dictionaries for additional type
checking.

```python
from types_aiobotocore_route53_recovery_control_config.type_defs import (
    AssertionRuleTypeDef,
    AssertionRuleUpdateTypeDef,
    ClusterEndpointTypeDef,
    ClusterTypeDef,
    ControlPanelTypeDef,
    CreateClusterRequestRequestTypeDef,
    CreateClusterResponseTypeDef,
    CreateControlPanelRequestRequestTypeDef,
    CreateControlPanelResponseTypeDef,
    CreateRoutingControlRequestRequestTypeDef,
    CreateRoutingControlResponseTypeDef,
    CreateSafetyRuleRequestRequestTypeDef,
    CreateSafetyRuleResponseTypeDef,
    DeleteClusterRequestRequestTypeDef,
    DeleteControlPanelRequestRequestTypeDef,
    DeleteRoutingControlRequestRequestTypeDef,
    DeleteSafetyRuleRequestRequestTypeDef,
    DescribeClusterRequestRequestTypeDef,
    DescribeClusterResponseTypeDef,
    DescribeControlPanelRequestRequestTypeDef,
    DescribeControlPanelResponseTypeDef,
    DescribeRoutingControlRequestRequestTypeDef,
    DescribeRoutingControlResponseTypeDef,
    DescribeSafetyRuleRequestRequestTypeDef,
    DescribeSafetyRuleResponseTypeDef,
    GatingRuleTypeDef,
    GatingRuleUpdateTypeDef,
    ListAssociatedRoute53HealthChecksRequestRequestTypeDef,
    ListAssociatedRoute53HealthChecksResponseTypeDef,
    ListClustersRequestRequestTypeDef,
    ListClustersResponseTypeDef,
    ListControlPanelsRequestRequestTypeDef,
    ListControlPanelsResponseTypeDef,
    ListRoutingControlsRequestRequestTypeDef,
    ListRoutingControlsResponseTypeDef,
    ListSafetyRulesRequestRequestTypeDef,
    ListSafetyRulesResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    NewAssertionRuleTypeDef,
    NewGatingRuleTypeDef,
    ResponseMetadataTypeDef,
    RoutingControlTypeDef,
    RuleConfigTypeDef,
    RuleTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateControlPanelRequestRequestTypeDef,
    UpdateControlPanelResponseTypeDef,
    UpdateRoutingControlRequestRequestTypeDef,
    UpdateRoutingControlResponseTypeDef,
    UpdateSafetyRuleRequestRequestTypeDef,
    UpdateSafetyRuleResponseTypeDef,
    WaiterConfigTypeDef,
)

def get_structure() -> AssertionRuleTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-route53-recovery-control-config` version is the same as
related `boto3` version and follows
[PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation

All type annotations can be found in
[types-aiobotocore-route53-recovery-control-config docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_route53_recovery_control_config/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
